blackValues = list of blacklisted values, i.e. array of Strings
actionSet   = list of actions, contains objects with 3 attributes:
  - action : String is the name of the action
  - skip   : Bool   is a boolean specifying whether the action has been skipped or not
  - sink   : Value  is a labeled value specifying the current value on the sink 


# context.js
- extend the Context `constructor` with actionSet and blackValues
- initially, all skips are false and values on sink are null


# jsflow.js
- extended with variables `sensitive` and `available`
- when executing ./jsflow with the flag `sensitive`, no blacklisted values are allowed on the sink; all variables should be low, since we do not want to enforce IFC in this case
- when executing ./jsflow with the flag `available`, skip statements will be ignored


# monitor.js
- extended the initialization function MonitorBase.prototype.initialize with instantiations of the actionSet and blackValues


# constants.js
- extended 'strings' with keywords 'sink' and 'skip'


# global.js
- extended ecma with several functions: sink/3 and skip/1, imgl/1, imgh/1, urll/1, urlh/2
- skip/1 takes as argument a string s; if s corresponds to one of the actions in actionSet, then the skip value corresponding to it will be set to true
- sink/3 takes as arguments two strings s1 and s2 and a labeled value v; 
		- s1 corresponds to the action, s2 to the action's ingredient
    - if the skip corresponding to action s1 in the actionSet is true, then nothing to do
    - else we update the value on the sink if 
         (1) pc <= label(v) and if 
         (2) if pc = H there no blacklisted values currently on the sink
- imgl/1 and imgh/1 are constructs for creating an image constructor; they take as argument a string s denoting the url of the image. imgl(s) is assumed to create an image of size 0x0; imgl cannot take as argument a string containing a high labeled value, while imgh cannot take as argument a string containing a blacklisted value.
- urll/1 and urlh/1 are constructs for creating URLs. urll is used for creating privately and publicly visible links. urll cannot take as argument a string containing a high labeled value, while urlh cannot take as argument a string containing a blacklisted value.


# exec.js
- we treat imgH and imgL as special variables 
- we extend the function 'assignmentOps' with the following checks:
    - an assignment made to imgH is allowed only if the value assigned does not contain     
      blacklisted strings
    - an assignment made to imgL is allowed if it is made in a low context and the label of the 
      value assigned is low
- this works only for statements as 'img* = ...', not for 'var img* = ...'

